package com.gymtracker.model;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name = "application")
public class Application implements Serializable {
    @Id
    @Column(nullable = false)
    private String username;

    @Id
    @Column(nullable = false)
    private int gym_id;

    @Column
    private String gym_name;
    
    @Column(nullable = false)
    private String email;

    @Column(nullable = false)
    private int acceptance;

    @Column(nullable = false)
    private String trainer_name;

    @Column(nullable = false)
    private String trainer_description;

    @Lob
    @Column(nullable = false)
    private String application_description;

    // Getters
    public String getUsername() {
        return username;
    }

    public int getGymID() {
        return gym_id;
    }

    public String getGymName() {
        return gym_name;
    }

    public String getEmail() {
        return email;
    }

    public int getAcceptance() {
        return acceptance;
    }

    public String getTrainerName() {
        return trainer_name;
    }

    public String getTrainerDescription() {
        return trainer_description;
    }

    public String getApplicationDescription() {
        return application_description;
    }

    public String toXML() {
        return "<application>" +
                "<username>" + username + "</username>" +
                "<gym_id>" + gym_id + "</gym_id>" +
                "<email>" + email + "</email>" +
                "<acceptance>" + acceptance + "</acceptance>" +
                "<trainer_name>" + trainer_name + "</trainer_name>" +
                "<trainer_description>" + trainer_description + "</trainer_description>" +
                "<application_description>" + application_description + "</application_description>" +
                "</application>";
    }

    public String toString() {
        return "[" + username + ", " + gym_id + ", " + acceptance + ", " + trainer_name + ", " + trainer_description + ", " + application_description + "]";
    }

    // Constructors
    public Application(String username, int gym_id, String gym_name, String email, int acceptance, String trainer_name) {
        this.username = username;
        this.gym_id = gym_id;
        this.gym_name = gym_name;
        this.email = email;
        this.acceptance = acceptance;
        this.trainer_name = trainer_name;
    }

    // Default constructor 
    public Application() {
    }


    //Setters
    public void setUsername(String username) {
        this.username = username;
    }

    public void setGymID(int gym_id) {
        this.gym_id = gym_id;
    }

    public void setGymName(String gym_name) {
        this.gym_name = gym_name;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public void setAcceptance(int acceptance) {
        this.acceptance = acceptance;
    }

    public void setTrainerName(String trainer_name) {
        this.trainer_name = trainer_name;
    }

    public void setTrainerDescription(String trainer_description) {
        this.trainer_description = trainer_description;
    }

    public void setApplicationDescription(String application_description) {
        this.application_description = application_description;
    }
}
